unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp;

type
  TForm1 = class(TForm)
    ServerSocket1: TServerSocket;
    Memo1: TMemo;
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
   Connected : boolean;
   TelnetS   : string;
   Function ExecuteCMD(ACmd : string):string;
   Function TelnetSendText(Socket: TCustomWinSocket; AText : string):boolean;
  end;

var
  Form1: TForm1;
const
  CRLF = #$0D + #$0A;
implementation

{$R *.DFM}

//  
function TForm1.ExecuteCMD(ACmd: string): string;
var
 UCmd, Params  : string;
begin
 Result := '';
 Memo1.Lines.Add(' : '+ACmd);
 if Not(connected) then begin
  if UpperCase(ACmd) = '123' then begin
   Connected := true;
   Result := '  !';
  end;
  exit;
 end;
 //  
 UCmd := ACmd;
 Params := '';
 if pos(' ', UCmd) > 0 then begin
  Params := Copy(UCmd, pos(' ', UCmd)+1, Length(UCmd));
  UCmd := Copy(UCmd, 1, pos(' ', UCmd)-1);
 end;
 UCmd := Trim(UpperCase(UCMD));
 Memo1.Lines.Add('  : '+UCmd);
 // ?  HLP  HELP -  
 if (UCmd = '?') or (UCmd = 'HLP') or (UCmd = 'HELP') then begin
  Result :=
   '    Telnet '+CRLF+
   '  ?, HLP, HELP -  '+CRLF+
   ' EXIT -    Telnen '+CRLF+
   ' HALT -   '+CRLF+
   ' VER -  '+CRLF+
   ' MESS <> -    '+CRLF+
   ' INP <> -        ';
  exit;
 end;
 if (UCmd = 'EXIT') then begin
  ServerSocket1.Socket.Connections[0].Close;
  exit;
 end;
 if (UCmd = 'VER') then begin
  Result := ' 1.00  27.01.2001 (C)  ';
  exit;
 end;
 if (UCmd = 'HALT') then begin
  halt;
 end;
 if (UCmd = 'MESS') then begin
  ShowMessage(Params);
  exit;
 end;
 if (UCmd = 'INP') then begin
  Result := InputBox(Params,' ','');
  exit;
 end;
 Result := '  '+ACmd;
end;

procedure TForm1.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 Socket.SendText('Connected.  Telnet1 Example  .'+#$0D+#$0A);
 Socket.SendText('Enter password : ');
 Connected := false;
 Memo1.Lines.Add('   ');
end;

procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 Connected := false;
 Memo1.Lines.Add(' ');
end;

procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
 s, st : string;
begin
 s := Socket.ReceiveText;
 //     ?  ,        
 if ord(s[1]) = $0D then begin
  st := ExecuteCMD(TelnetS);
  if st <> '' then
   st := #$0D + #$0A + st;
  st := st + #$0D + #$0A + '>';
  TelnetSendText(Socket, st);
  TelnetS := '';
  exit;
 end;
 //    BackSpace.  ,    
 //      
 if ord(s[1]) = $08 then begin
  Delete(TelnetS,length(TelnetS),1);
  TelnetSendText(Socket, s);
  exit;
 end;
 //     
 TelnetS := TelnetS+s;
 //      
 if connected then
  TelnetSendText(Socket, s);
end;

function TForm1.TelnetSendText(Socket: TCustomWinSocket; AText: string): boolean;
var
 i  : integer;
 St : string;
begin
 Result := false;
 if Not(connected) then
  exit;
 St := '';
 for i := 1 to length(AText) do
  if AText[i] <> #$FF then st := st + AText[i]
   else st := st + #$FF + #$FF;
 Socket.SendText(st);
end;

procedure TForm1.ServerSocket1ClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
 //   " "
 if ErrorCode = 10054 then begin
  Socket.Close;
  ErrorCode := 0;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Connected := false;
 TelnetS   := '';
end;

end.
